use kernel::prelude::*;

module! {
    type: BasicModule,
    name: "basic_module",
    author: "Florian RICHER <florian.richer@protonmail.com>",
    description: "Un module noyau qui affiche un message",
    license: "GPL",
}

struct BasicModule;

impl kernel::Module for BasicModule {
    fn init(_module: &'static ThisModule) -> Result<Self> {
        pr_info!("Bonjour! Le module est chargé.\n");

        Ok(BasicModule)
    }
}

impl Drop for BasicModule {
    fn drop(&mut self) {
        pr_info!("Au revoir! Le module est déchargé.\n");
    }
}
